diff -Naur linux-source-2.6.34.1.orig/arch/x86/include/asm/alternative.h linux-source-2.6.34.1/arch/x86/include/asm/alternative.h
--- linux-source-2.6.34.1.orig/arch/x86/include/asm/alternative.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/arch/x86/include/asm/alternative.h	2011-02-18 12:33:40.000000000 +0000
@@ -132,8 +132,8 @@
 
 /* Like alternative_io, but for replacing a direct call with another one. */
 #define alternative_call(oldfunc, newfunc, feature, output, input...)	\
-	asm volatile (ALTERNATIVE("call %P[old]", "call %P[new]", feature) \
-		: output : [old] "i" (oldfunc), [new] "i" (newfunc), ## input)
+	asm volatile (ALTERNATIVE("call %P[old]", "call %P[_new]", feature) \
+		: output : [old] "i" (oldfunc), [_new] "i" (newfunc), ## input)
 
 /*
  * use this macro(s) if you need more than one output parameter
diff -Naur linux-source-2.6.34.1.orig/arch/x86/include/asm/linkage.h linux-source-2.6.34.1/arch/x86/include/asm/linkage.h
--- linux-source-2.6.34.1.orig/arch/x86/include/asm/linkage.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/arch/x86/include/asm/linkage.h	2011-02-18 12:33:40.000000000 +0000
@@ -4,7 +4,8 @@
 #include <linux/stringify.h>
 
 #undef notrace
-#define notrace __attribute__((no_instrument_function))
+/* #define notrace __attribute__((no_instrument_function)) */
+#define notrace
 
 #ifdef CONFIG_X86_32
 #define asmlinkage CPP_ASMLINKAGE __attribute__((regparm(0)))
diff -Naur linux-source-2.6.34.1.orig/arch/x86/include/asm/pgtable_types.h linux-source-2.6.34.1/arch/x86/include/asm/pgtable_types.h
--- linux-source-2.6.34.1.orig/arch/x86/include/asm/pgtable_types.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/arch/x86/include/asm/pgtable_types.h	2011-02-18 12:33:40.000000000 +0000
@@ -257,7 +257,7 @@
 
 static inline pte_t native_make_pte(pteval_t val)
 {
-	return (pte_t) { .pte = val };
+  return (pte_t) { val };
 }
 
 static inline pteval_t native_pte_val(pte_t pte)
diff -Naur linux-source-2.6.34.1.orig/arch/x86/include/asm/vdso.h linux-source-2.6.34.1/arch/x86/include/asm/vdso.h
--- linux-source-2.6.34.1.orig/arch/x86/include/asm/vdso.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/arch/x86/include/asm/vdso.h	2011-02-18 12:33:40.000000000 +0000
@@ -33,8 +33,8 @@
  * These symbols are defined with the addresses in the vsyscall page.
  * See vsyscall-sigreturn.S.
  */
-extern void __user __kernel_sigreturn;
-extern void __user __kernel_rt_sigreturn;
+extern unsigned long __user __kernel_sigreturn;
+extern unsigned long __user __kernel_rt_sigreturn;
 
 /*
  * These symbols are defined by vdso32.S to mark the bounds
diff -Naur linux-source-2.6.34.1.orig/include/linux/cpumask.h linux-source-2.6.34.1/include/linux/cpumask.h
--- linux-source-2.6.34.1.orig/include/linux/cpumask.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/include/linux/cpumask.h	2011-02-18 12:33:40.000000000 +0000
@@ -230,9 +230,9 @@
  *
  * After the loop, cpu is >= nr_cpu_ids.
  */
-#define for_each_cpu_and(cpu, mask, and)				\
+#define for_each_cpu_and(cpu, mask, _and)				\
 	for ((cpu) = -1;						\
-		(cpu) = cpumask_next_and((cpu), (mask), (and)),		\
+		(cpu) = cpumask_next_and((cpu), (mask), (_and)),	\
 		(cpu) < nr_cpu_ids;)
 #endif /* SMP */
 
diff -Naur linux-source-2.6.34.1.orig/include/linux/hrtimer.h linux-source-2.6.34.1/include/linux/hrtimer.h
--- linux-source-2.6.34.1.orig/include/linux/hrtimer.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/include/linux/hrtimer.h	2011-02-18 12:33:40.000000000 +0000
@@ -214,8 +214,8 @@
 
 static inline void hrtimer_add_expires_ns(struct hrtimer *timer, u64 ns)
 {
-	timer->_expires = ktime_add_ns(timer->_expires, ns);
-	timer->_softexpires = ktime_add_ns(timer->_softexpires, ns);
+	timer->_expires.tv64 = timer->_expires.tv64 + ns;
+	timer->_softexpires.tv64 = timer->_softexpires.tv64 + ns;
 }
 
 static inline ktime_t hrtimer_get_expires(const struct hrtimer *timer)
@@ -244,7 +244,11 @@
 
 static inline ktime_t hrtimer_expires_remaining(const struct hrtimer *timer)
 {
-    return ktime_sub(timer->_expires, timer->base->get_time());
+  ktime_t res;
+
+  res.tv64 = timer->_expires.tv64 - timer->base->get_time().tv64;
+
+  return res;
 }
 
 #ifdef CONFIG_HIGH_RES_TIMERS
@@ -358,7 +362,7 @@
 	ktime_t soft, hard;
 	soft = hrtimer_get_softexpires(timer);
 	hard = hrtimer_get_expires(timer);
-	delta = ktime_to_ns(ktime_sub(hard, soft));
+	delta = hard.tv64 - soft.tv64;
 	return hrtimer_start_range_ns(timer, soft, delta, mode);
 }
 
diff -Naur linux-source-2.6.34.1.orig/include/linux/ktime.h linux-source-2.6.34.1/include/linux/ktime.h
--- linux-source-2.6.34.1.orig/include/linux/ktime.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/include/linux/ktime.h	2011-02-18 12:33:40.000000000 +0000
@@ -80,11 +80,16 @@
  */
 static inline ktime_t ktime_set(const long secs, const unsigned long nsecs)
 {
+  ktime_t res;
+
 #if (BITS_PER_LONG == 64)
-	if (unlikely(secs >= KTIME_SEC_MAX))
-		return (ktime_t){ .tv64 = KTIME_MAX };
+ if (unlikely(secs >= KTIME_SEC_MAX)) {
+   res.tv64 = KTIME_MAX;
+   return res;
+ }
 #endif
-	return (ktime_t) { .tv64 = (s64)secs * NSEC_PER_SEC + (s64)nsecs };
+ res.tv64 = (s64)secs * NSEC_PER_SEC + (s64)nsecs;
+ return res;
 }
 
 /* Subtract two ktime_t variables. rem = lhs -rhs: */
@@ -297,17 +302,29 @@
 
 static inline s64 ktime_us_delta(const ktime_t later, const ktime_t earlier)
 {
-       return ktime_to_us(ktime_sub(later, earlier));
+  ktime_t sub;
+
+  sub.tv64 = later.tv64 - earlier.tv64;
+
+  return ktime_to_us(sub);
 }
 
 static inline ktime_t ktime_add_us(const ktime_t kt, const u64 usec)
 {
-	return ktime_add_ns(kt, usec * 1000);
+  ktime_t res;
+
+  res.tv64 = kt.tv64 + (usec * 1000);
+
+  return res;
 }
 
 static inline ktime_t ktime_sub_us(const ktime_t kt, const u64 usec)
 {
-	return ktime_sub_ns(kt, usec * 1000);
+  ktime_t res;
+
+  res.tv64 = kt.tv64 - (usec * 1000);
+
+  return res;
 }
 
 extern ktime_t ktime_add_safe(const ktime_t lhs, const ktime_t rhs);
@@ -329,8 +346,11 @@
 
 static inline ktime_t ns_to_ktime(u64 ns)
 {
-	static const ktime_t ktime_zero = { .tv64 = 0 };
-	return ktime_add_ns(ktime_zero, ns);
+  ktime_t res;
+
+  res.tv64 = ns;
+
+  return res;
 }
 
 #endif
diff -Naur linux-source-2.6.34.1.orig/include/linux/semaphore.h linux-source-2.6.34.1/include/linux/semaphore.h
--- linux-source-2.6.34.1.orig/include/linux/semaphore.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/include/linux/semaphore.h	2011-02-18 12:33:40.000000000 +0000
@@ -31,9 +31,9 @@
 
 static inline void sema_init(struct semaphore *sem, int val)
 {
-	static struct lock_class_key __key;
-	*sem = (struct semaphore) __SEMAPHORE_INITIALIZER(*sem, val);
-	lockdep_init_map(&sem->lock.dep_map, "semaphore->lock", &__key, 0);
+	sem->lock.rlock.raw_lock.slock = 0;
+	sem->count = val;
+	sem->wait_list.prev = sem->wait_list.next = &(sem->wait_list);
 }
 
 #define init_MUTEX(sem)		sema_init(sem, 1)
diff -Naur linux-source-2.6.34.1.orig/include/linux/smp.h linux-source-2.6.34.1/include/linux/smp.h
--- linux-source-2.6.34.1.orig/include/linux/smp.h	2010-07-05 18:24:10.000000000 +0000
+++ linux-source-2.6.34.1/include/linux/smp.h	2011-02-18 12:33:40.000000000 +0000
@@ -43,28 +43,28 @@
 /*
  * stops all CPUs but the current one:
  */
-extern void smp_send_stop(void);
+static void smp_send_stop(void);
 
 /*
  * sends a 'reschedule' event to another CPU:
  */
-extern void smp_send_reschedule(int cpu);
+static void smp_send_reschedule(int cpu);
 
 
 /*
  * Prepare machine for booting other CPUs.
  */
-extern void smp_prepare_cpus(unsigned int max_cpus);
+extern inline void smp_prepare_cpus(unsigned int max_cpus);
 
 /*
  * Bring a CPU up
  */
-extern int __cpu_up(unsigned int cpunum);
+extern inline int __cpu_up(unsigned int cpunum);
 
 /*
  * Final polishing of CPUs
  */
-extern void smp_cpus_done(unsigned int max_cpus);
+extern inline void smp_cpus_done(unsigned int max_cpus);
 
 /*
  * Call a function on all other processors
@@ -110,7 +110,7 @@
  * Mark the boot cpu "online" so that it can call console drivers in
  * printk() and can access its per-cpu storage.
  */
-void smp_prepare_boot_cpu(void);
+static void smp_prepare_boot_cpu(void);
 
 extern unsigned int setup_max_cpus;
 
